| OpenCV 5.0.0alpha Open Source Computer Vision

Loading...
Searching...
No Matches
Public Member Functions | List of all members
cv::Feature2D Class Reference
Features Framework » Feature Detection and Description

Abstract base class for 2D image feature detectors and descriptor extractors. More...

`#include <opencv2/features.hpp>`

Collaboration diagram for cv::Feature2D:

## Public Member Functions
virtual | ~Feature2D ()
virtual void | compute (InputArray image, std::vector< KeyPoint > &keypoints, OutputArray descriptors)
| Computes the descriptors for a set of keypoints detected in an image (first variant) or image set (second variant).
virtual void | compute (InputArrayOfArrays images, std::vector< std::vector< KeyPoint > > &keypoints, OutputArrayOfArrays descriptors)
virtual int | defaultNorm () const
virtual int | descriptorSize () const
virtual int | descriptorType () const
virtual void | detect (InputArray image, std::vector< KeyPoint > &keypoints, InputArray mask=noArray())
| Detects keypoints in an image (first variant) or image set (second variant).
virtual void | detect (InputArrayOfArrays images, std::vector< std::vector< KeyPoint > > &keypoints, InputArrayOfArrays masks=noArray())
virtual void | detectAndCompute (InputArray image, InputArray mask, std::vector< KeyPoint > &keypoints, OutputArray descriptors, bool useProvidedKeypoints=false)
virtual bool | empty () const CV_OVERRIDE
| Return true if detector object is empty.
virtual String | getDefaultName () const CV_OVERRIDE
virtual void | read (const FileNode &) CV_OVERRIDE
| Reads algorithm parameters from a file storage.
void | read (const String &fileName)
void | write (const String &fileName) const
virtual void | write (FileStorage &) const CV_OVERRIDE
| Stores algorithm parameters in a file storage.
void | write (FileStorage &fs, const String &name) const
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state.
virtual void | save (const String &filename) const
void | write (FileStorage &fs, const String &name) const

## Additional Inherited Members
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file.
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String.
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node.
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

Abstract base class for 2D image feature detectors and descriptor extractors.

## Constructor & Destructor Documentation

## ◆ ~Feature2D()

virtual cv::Feature2D::~Feature2D | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ compute() [1/2]

virtual void cv::Feature2D::compute | ( | InputArray | image,
|  | std::vector< KeyPoint > & | keypoints,
|  | OutputArray | descriptors )
| virtual

Python:
| cv.Feature2D.compute( | image, keypoints[, descriptors] | ) -> | keypoints, descriptors
| cv.Feature2D.compute( | images, keypoints[, descriptors] | ) -> | keypoints, descriptors

Computes the descriptors for a set of keypoints detected in an image (first variant) or image set (second variant).

Parameters

  image | Image.
  keypoints | Input collection of keypoints. Keypoints for which a descriptor cannot be computed are removed. Sometimes new keypoints can be added, for example: SIFT duplicates keypoint with several dominant orientations (for each orientation).
  descriptors | Computed descriptors. In the second variant of the method descriptors[i] are descriptors computed for a keypoints[i]. Row j is the keypoints (or keypoints[i]) is the descriptor for keypoint j-th keypoint.

Reimplemented in cv::xfeatures2d::DAISY.

## ◆ compute() [2/2]

virtual void cv::Feature2D::compute | ( | InputArrayOfArrays | images,
|  | std::vector< std::vector< KeyPoint > > & | keypoints,
|  | OutputArrayOfArrays | descriptors )
| virtual

Python:
| cv.Feature2D.compute( | image, keypoints[, descriptors] | ) -> | keypoints, descriptors
| cv.Feature2D.compute( | images, keypoints[, descriptors] | ) -> | keypoints, descriptors

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Parameters

  images | Image set.
  keypoints | Input collection of keypoints. Keypoints for which a descriptor cannot be computed are removed. Sometimes new keypoints can be added, for example: SIFT duplicates keypoint with several dominant orientations (for each orientation).
  descriptors | Computed descriptors. In the second variant of the method descriptors[i] are descriptors computed for a keypoints[i]. Row j is the keypoints (or keypoints[i]) is the descriptor for keypoint j-th keypoint.

Reimplemented in cv::xfeatures2d::DAISY.

## ◆ defaultNorm()

virtual int cv::Feature2D::defaultNorm | ( |  | ) | const
| virtual

Python:
| cv.Feature2D.defaultNorm( |  | ) -> | retval

## ◆ descriptorSize()

virtual int cv::Feature2D::descriptorSize | ( |  | ) | const
| virtual

Python:
| cv.Feature2D.descriptorSize( |  | ) -> | retval

## ◆ descriptorType()

virtual int cv::Feature2D::descriptorType | ( |  | ) | const
| virtual

Python:
| cv.Feature2D.descriptorType( |  | ) -> | retval

## ◆ detect() [1/2]

virtual void cv::Feature2D::detect | ( | InputArray | image,
|  | std::vector< KeyPoint > & | keypoints,
|  | InputArray | mask = noArray() )
| virtual

Python:
| cv.Feature2D.detect( | image[, mask] | ) -> | keypoints
| cv.Feature2D.detect( | images[, masks] | ) -> | keypoints

Detects keypoints in an image (first variant) or image set (second variant).

Parameters

  image | Image.
  keypoints | The detected keypoints. In the second variant of the method keypoints[i] is a set of keypoints detected in images[i] .
  mask | Mask specifying where to look for keypoints (optional). It must be a 8-bit integer matrix with non-zero values in the region of interest.

Reimplemented in cv::xfeatures2d::AffineFeature2D.

Here is the call graph for this function:

## ◆ detect() [2/2]

virtual void cv::Feature2D::detect | ( | InputArrayOfArrays | images,
|  | std::vector< std::vector< KeyPoint > > & | keypoints,
|  | InputArrayOfArrays | masks = noArray() )
| virtual

Python:
| cv.Feature2D.detect( | image[, mask] | ) -> | keypoints
| cv.Feature2D.detect( | images[, masks] | ) -> | keypoints

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Parameters

  images | Image set.
  keypoints | The detected keypoints. In the second variant of the method keypoints[i] is a set of keypoints detected in images[i] .
  masks | Masks for each input image specifying where to look for keypoints (optional). masks[i] is a mask for images[i].

Reimplemented in cv::xfeatures2d::AffineFeature2D.

Here is the call graph for this function:

## ◆ detectAndCompute()

virtual void cv::Feature2D::detectAndCompute | ( | InputArray | image,
|  | InputArray | mask,
|  | std::vector< KeyPoint > & | keypoints,
|  | OutputArray | descriptors,
|  | bool | useProvidedKeypoints = false )
| virtual

Python:
| cv.Feature2D.detectAndCompute( | image, mask[, descriptors[, useProvidedKeypoints]] | ) -> | keypoints, descriptors

Detects keypoints and computes the descriptors

Reimplemented in cv::xfeatures2d::AffineFeature2D.

## ◆ empty()

virtual bool cv::Feature2D::empty | ( |  | ) | const
| virtual

Python:
| cv.Feature2D.empty( |  | ) -> | retval

Return true if detector object is empty.

Reimplemented from cv::Algorithm.

## ◆ getDefaultName()

virtual String cv::Feature2D::getDefaultName | ( |  | ) | const
| virtual

Python:
| cv.Feature2D.getDefaultName( |  | ) -> | retval

Returns the algorithm string identifier. This string is used as top level xml/yml node tag when the object is saved to a file or string.

Reimplemented from cv::Algorithm.

Reimplemented in cv::AffineFeature, cv::FastFeatureDetector, cv::GFTTDetector, cv::MSER, cv::ORB, cv::SIFT, cv::SimpleBlobDetector, cv::xfeatures2d::AgastFeatureDetector, cv::xfeatures2d::AKAZE, cv::xfeatures2d::BEBLID, cv::xfeatures2d::BoostDesc, cv::xfeatures2d::BriefDescriptorExtractor, cv::xfeatures2d::BRISK, cv::xfeatures2d::DAISY, cv::xfeatures2d::FREAK, cv::xfeatures2d::HarrisLaplaceFeatureDetector, cv::xfeatures2d::KAZE, cv::xfeatures2d::LATCH, cv::xfeatures2d::LUCID, cv::xfeatures2d::MSDDetector, cv::xfeatures2d::StarDetector, cv::xfeatures2d::SURF, cv::xfeatures2d::TBMR, cv::xfeatures2d::TEBLID, and cv::xfeatures2d::VGG.

## ◆ read() [1/2]

virtual void cv::Feature2D::read | ( | const FileNode & | fn | ) |
| virtual

Python:
| cv.Feature2D.read( | fileName | ) -> | None
| cv.Feature2D.read( | arg1 | ) -> | None

Reads algorithm parameters from a file storage.

Reimplemented from cv::Algorithm.

## ◆ read() [2/2]

void cv::Feature2D::read | ( | const String & | fileName | ) |

Python:
| cv.Feature2D.read( | fileName | ) -> | None
| cv.Feature2D.read( | arg1 | ) -> | None

## ◆ write() [1/3]

void cv::Feature2D::write | ( | const String & | fileName | ) | const

Python:
| cv.Feature2D.write( | fileName | ) -> | None
| cv.Feature2D.write( | fs, name | ) -> | None

## ◆ write() [2/3]

virtual void cv::Feature2D::write | ( | FileStorage & | fs | ) | const
| virtual

Python:
| cv.Feature2D.write( | fileName | ) -> | None
| cv.Feature2D.write( | fs, name | ) -> | None

Stores algorithm parameters in a file storage.

Reimplemented from cv::Algorithm.

## ◆ write() [3/3]

void cv::Feature2D::write | ( | FileStorage & | fs,
|  | const String & | name ) const
| inline

Python:
| cv.Feature2D.write( | fileName | ) -> | None
| cv.Feature2D.write( | fs, name | ) -> | None

The documentation for this class was generated from the following file:

- opencv2/features.hpp